/*!
 * mixpanel-lite.js - v1.5.9
 * Lightweight version of mixpanel-js with offline support
 * https://github.com/john-doherty/mixpanel-lite
 * @author John Doherty <www.johndoherty.info>
 * @license MIT
 */
!function(e,t){if(e.localStorage)if(e.Promise){var n=localStorage,r="https://api.mixpanel.com/track?ip=1&verbose=1&data=",i="https://api.mixpanel.com/engage?ip=1&verbose=1&data=",o=null,a=!1,l=!1,s=null,c=(new Date).getTime(),d=0,u={},g=function(e){var t=String(n.getItem(e));if("null"===t)return null;if("undefined"!==t){if(/^[0-9.]+$/.test(t))return parseFloat(t);if(/^[-0-9]+$/.test(t))return parseInt(t,10);if("true"===t||"false"===t)return"true"===t;if("{"===t[0]||"["===t[0])try{var r=JSON.parse(t);if("object"==typeof r||Array.isArray(r))return r}catch(e){}return t}},f=function(e,t){if("string"!=typeof e)throw new TypeError("localStorage: Key must be a string");("object"==typeof t||Array.isArray(t))&&(t=JSON.stringify(t)),n.setItem(e,t)},p={_key:"mixpanel-lite",_maxLength:100,all:function(){return g(p._key)||[]},add:function(e){var t=p.all();d++,e._id=c+"-"+d,t.length+1>p._maxLength&&t.shift(),t.push(e),f(p._key,t)},remove:function(e){var t=(e||[]).map(function(e){return e._id}),n=p.all().filter(function(e){return-1===t.indexOf(e._id)});f(p._key,n)},clear:function(){f(p._key,[])}},m={init:function(e,t){console.log("mixpanel.track('"+e+"',"+JSON.stringify(t||{})+")")},track:function(e,t){console.log("mixpanel.track('"+e+"',"+JSON.stringify(t||{})+")")},register:function(e){console.log("mixpanel.register("+JSON.stringify(e||{})+")")},reset:function(){console.log("mixpanel.reset()")},identify:function(e){console.log("mixpanel.identify('"+e+"')")},getProperty:function(e){console.log("mixpanel.getProperty('"+e+"')")},people:{set:function(e){console.log("mixpanel.people.set("+JSON.stringify(e||{})+")")}},mute:O,unmute:$,muted:!0},h={init:B,track:y,register:function(e){Object.keys(e||{}).forEach(function(t){null!==e[t]&&""!==e[t]?u[t]=e[t]:delete u[t]})},reset:function(){B(o),a&&console.log("mixpanel.reset()")},identify:function(e){e&&""!==e.trim()?(a&&console.log("mixpanel.identify('"+e+"')"),y("$identify",{$anon_distinct_id:u.distinct_id,distinct_id:e,$user_id:e}),u.distinct_id=e,u.$user_id=e):console.warn("mixpanel.identify: Invalid id")},getProperty:function(e){return u[e]},people:{set:function(e){if(e&&"object"==typeof e){var t={$token:o,$distinct_id:u.distinct_id,$set:{}};Object.keys(e||{}).forEach(function(n){t.$set[n]=e[n]}),Object.keys(t.$set).forEach(function(e){null!==t.$set[e]&&""!==t.$set[e]||delete t.$set[e]}),p.add(t),_(),a&&(console.log("mixpanel.people.set("+JSON.stringify(e||{})+")"),console.dir(t))}else console.warn("mixpanel.setPeople: Invalid data param, must be an object")}},mute:O,unmute:$,muted:!1};e.mixpanel=h,e.addEventListener(e.cordova?"deviceready":"load",_,{passive:!0}),e.addEventListener("online",_,{passive:!0})}else console.warn("mixpanel-lite: Promise not supported (try adding a polyfill)");else console.warn("mixpanel-lite: localStorage not supported");function v(){var e=navigator.connection||navigator.mozConnection||navigator.webkitConnection||{};return e.effectiveType||e.type||""}function y(t,n){if(o)if(t&&""!==t)if(n&&"object"!=typeof n)console.warn("mixpanel.track: Data param must be an object");else{var r={event:t,properties:k(u)};Object.keys(n||{}).forEach(function(e){r.properties[e]=n[e]}),r.properties.$insert_id=Math.random().toString(36).substring(2,10)+Math.random().toString(36).substring(2,10),r.properties.time=Math.round((new Date).getTime()/1e3),Object.keys(r.properties).forEach(function(e){null!==r.properties[e]&&""!==r.properties[e]||delete r.properties[e]}),e.navigator.onLine||(r.properties.offline=!0),function(){if(e._phantom||e.phantom)return!0;if(e.__nightmare)return!0;if(navigator.webdriver)return!0;if(e.Cypress)return!0;if(/HeadlessChrome/.test(e.navigator.userAgent))return!0;if(0===screen.width||0===screen.height)return!0;return!1}()&&(r.properties.automated=!0),(/^localhost$|^127(\.[0-9]+){0,2}\.[0-9]+$|^\[::1?\]$/.test(location.hostname)||"file:"===location.protocol)&&(r.properties.dev=!0),p.add(r),_(),a&&(n?console.log("mixpanel.track('"+t+"',"+JSON.stringify(n||{})+")"):console.log("mixpanel.track('"+t+"')"),console.dir(r))}else console.warn("mixpanel.track: Invalid eventName");else console.warn("mixpanel.track: You must call mixpanel.init(token) first")}function _(){if(l)return s&&clearTimeout(s),void(s=setTimeout(_,500));var t=p.all();if(-1!==t.length){l=!0,s&&(clearTimeout(s),s=null);var n,o,c=t.map(function(t){return function(){var n=t.$set?i:r,o=k(t);delete o._id;var a,l=(a=JSON.stringify(o),e.btoa(unescape(encodeURIComponent(a))));return function(e){return new Promise(function(t,n){var r=new XMLHttpRequest;r.open("GET",e),r.withCredentials=!0,r.onreadystatechange=function(){4===r.readyState&&(200===r.status?t({url:e,status:200,body:r.responseText||""}):n({url:e,status:r.status,body:r.responseText||""}))},r.send()})}(n+=encodeURIComponent(l)+"&_="+(new Date).getTime()).then(function(){t.__completed=!0})}});(n=c,o=Promise.resolve(),n.forEach(function(e){o=o.then(e)}),o).then(function(){var e=t.filter(function(e){return e.__completed});p.remove(e),l=!1}).catch(function(e){a&&console.log(e),l=!1})}}function k(e){return JSON.parse(JSON.stringify(e))}function x(){var e=navigator.userAgent;return/Windows Phone/i.test(e)||/WPDesktop/.test(e)?"Windows Phone":/iPad/.test(e)?"iPad":/iPod/.test(e)?"iPod Touch":/iPhone/.test(e)?"iPhone":/(BlackBerry|PlayBook|BB10)/i.test(e)?"BlackBerry":/Android/.test(e)?"Android":""}function S(e,t){return-1!==e.indexOf(t)}function b(){var t=navigator.userAgent,n=navigator.vendor||"";return e.opera||S(t," OPR/")?S(t,"Mini")?"Opera Mini":"Opera":/(BlackBerry|PlayBook|BB10)/i.test(t)?"BlackBerry":S(t,"IEMobile")||S(t,"WPDesktop")?"Internet Explorer Mobile":S(t,"Edge")?"Microsoft Edge":S(t,"FBIOS")?"Facebook Mobile":S(t,"Chrome")?"Chrome":S(t,"CriOS")?"Chrome iOS":S(t,"UCWEB")||S(t,"UCBrowser")?"UC Browser":S(t,"FxiOS")?"Firefox iOS":S(n,"Apple")?S(t,"Mobile")?"Mobile Safari":"Safari":S(t,"Android")?"Android Mobile":S(t,"Konqueror")?"Konqueror":S(t,"Firefox")?"Firefox":S(t,"MSIE")||S(t,"Trident/")?"Internet Explorer":S(t,"Gecko")?"Mozilla":""}function w(){var e=b(),t=navigator.userAgent,n={"Internet Explorer Mobile":/rv:(\d+(\.\d+)?)/,"Microsoft Edge":/Edge\/(\d+(\.\d+)?)/,Chrome:/Chrome\/(\d+(\.\d+)?)/,"Chrome iOS":/CriOS\/(\d+(\.\d+)?)/,"UC Browser":/(UCBrowser|UCWEB)\/(\d+(\.\d+)?)/,Safari:/Version\/(\d+(\.\d+)?)/,"Mobile Safari":/Version\/(\d+(\.\d+)?)/,Opera:/(Opera|OPR)\/(\d+(\.\d+)?)/,Firefox:/Firefox\/(\d+(\.\d+)?)/,"Firefox iOS":/FxiOS\/(\d+(\.\d+)?)/,Konqueror:/Konqueror:(\d+(\.\d+)?)/,BlackBerry:/BlackBerry (\d+(\.\d+)?)/,"Android Mobile":/android\s(\d+(\.\d+)?)/,"Internet Explorer":/(rv:|MSIE )(\d+(\.\d+)?)/,Mozilla:/rv:(\d+(\.\d+)?)/}[e];if(void 0===n)return null;var r=t.match(n);return r?parseFloat(r[r.length-2]):null}function O(){e.mixpanel=m}function $(){e.mixpanel=h}function B(n,l){if(!0===(l=l||{}).mute&&(e.mixpanel=m),l.trackingUrl&&""!==l.trackingUrl&&(r=l.trackingUrl),l.engageUrl&&""!==l.engageUrl&&(i=l.engageUrl),""!==(n=String(n||""))){o=n,a=!0===l.debug;var s,c,d,g,f=(s=function(){var t,n=1*new Date;if(e.performance&&e.performance.now)t=e.performance.now();else for(t=0;n==1*new Date;)t++;return n.toString(16)+Math.floor(t).toString(16)},c=(screen.height*screen.width).toString(16),s()+"-"+Math.random().toString(16).replace(".","")+"-"+function(){var e,t,n=navigator.userAgent,r=[],i=0;function o(e,t){var n,i=0;for(n=0;n<t.length;n++)i|=r[n]<<8*n;return e^i}for(e=0;e<n.length;e++)t=n.charCodeAt(e),r.unshift(255&t),r.length>=4&&(i=o(i,r),r=[]);return r.length>0&&(i=o(i,r)),i.toString(16)}()+"-"+c+"-"+s());u={token:n,$os:(g=navigator.userAgent,/Windows/i.test(g)?/Phone/.test(g)||/WPDesktop/.test(g)?"Windows Phone":"Windows":/(iPhone|iPad|iPod)/.test(g)?"iOS":/Android/.test(g)?"Android":/(BlackBerry|PlayBook|BB10)/i.test(g)?"BlackBerry":/Mac/i.test(g)?"Mac OS X":/Linux/.test(g)?"Linux":/CrOS/.test(g)?"Chrome OS":""),$browser:b(),$browser_version:w(),$device:x(),$screen_height:screen.height,$screen_width:screen.width,$referrer:t.referrer,$referring_domain:(d=String(t.referrer||"").split("/"),d.length>=3?d[2]:""),distinct_id:f,$device_id:f,mp_lib:"mixpanel-lite",$lib_version:"1.5.9",language:navigator.languages&&navigator.languages.length?navigator.languages[0]:navigator.language||navigator.userLanguage||navigator.browserLanguage||navigator.systemLanguage||"en"};var p=function(){var t=new URLSearchParams(e.location.search||""),n={};return t.has("utm_source")&&(n.source=t.get("utm_source")),t.has("utm_medium")&&(n.medium=t.get("utm_medium")),t.has("utm_campaign")&&(n.campaign=t.get("utm_campaign")),t.has("utm_term")&&(n.term=t.get("utm_term")),t.has("utm_content")&&(n.content=t.get("utm_content")),Object.keys(n).length>0?n:null}();p&&(u.utm=p);var h,y,_=(h=new URLSearchParams(e.location.search||""),y={},h.has("dclid")&&(y.dclid=h.get("dclid")),h.has("fbclid")&&(y.fbclid=h.get("fbclid")),h.has("gclid")&&(y.gclid=h.get("gclid")),h.has("ko_click_id")&&(y.ko_click_id=h.get("ko_click_id")),h.has("li_fat_id")&&(y.li_fat_id=h.get("li_fat_id")),h.has("msclkid")&&(y.msclkid=h.get("msclkid")),h.has("ttclid")&&(y.ttclid=h.get("ttclid")),h.has("twclid")&&(y.twclid=h.get("twclid")),h.has("wbraid")&&(y.wbraid=h.get("wbraid")),Object.keys(y).length>0?y:null);_&&(u.ad=_),0===String(e.location.protocol).indexOf("http")&&(u.$current_url=e.location.href),"1"===String(navigator.doNotTrack||"0")&&(u.doNotTrack=!0),e.device&&(e.device.manufacturer&&(u.$manufacturer=e.device.manufacturer),e.device.model&&(u.$model=e.device.model),e.device.version&&(u.$os_version=e.device.version)),u.connectionType=v();var k=navigator.connection||navigator.mozConnection||navigator.webkitConnection;k&&k.addEventListener&&k.addEventListener("change",function(){u.connectionType=v()}),a&&console.log("mixpanel.init('"+o+"')")}else console.warn("mixpanel.init: invalid token")}}(this,document);